<?php

	IPSUtils_Include ("IPSLogger.inc.php","IPSLibrary::app::core::IPSLogger");
  
  $debug = true;

  if ( !isset($_GET["device"] ) )
    {
    if ( $debug ) IPSLogger_Dbg(__FILE__,"Kein Device angegeben");
    echo "Kein Device angegeben";
    return;
    }

  if ( !isset( $_POST["date"] ) )
    {
    if ( $debug ) IPSLogger_Dbg(__FILE__,"Verbindungstest");
    echo "Verbindungstest";
    return;
    }
    
  $device = $_GET["device"]; 
  if ( $debug ) IPSLogger_Dbg(__FILE__,$device);
  
  foreach( $_POST as $data )
    if ( $debug ) IPSLogger_Dbg(__FILE__,$data);
    
  if ( isset( $_POST["date"] ) )     $date         =$_POST["date"] ;      else $date="";
  if ( isset( $_POST["name"] ) )     $locationName =$_POST["name"] ;      else $locationName="";
  if ( isset( $_POST["id"] ) )       $locationID   =$_POST["id"] ;        else $locationID="";
  if ( isset( $_POST["longitude"] ) )$longitude    =$_POST["longitude"] ; else $longitude="";
  if ( isset( $_POST["latitude"] ) ) $latitude     =$_POST["latitude"] ;  else $latitude="";
  if ( isset( $_POST["entry"] ) )    $isEntry      =$_POST["entry"] ;     else $isEntry="";

  
  $IDakt  = IPSUtil_ObjectIDByPath("Program.IPSLibrary.data.privat.Informationen.Geofencing.".$device.".AktuellePosition");
  $IDlast = IPSUtil_ObjectIDByPath("Program.IPSLibrary.data.privat.Informationen.Geofencing.".$device.".LetztePosition");
           
  if ($isEntry)
    {
    SetValue(IPS_GetVariableIDByName('AnkunftDatumZeit',$IDakt),time());
    SetValue(IPS_GetVariableIDByName('Latitude',$IDakt),$latitude);
    SetValue(IPS_GetVariableIDByName('Longitude',$IDakt),$longitude);
    SetValue(IPS_GetVariableIDByName('LocationID',$IDakt),$locationID);
    SetValue(IPS_GetVariableIDByName('LocationName',$IDakt),$locationName);

    $dev = str_pad ( $device, 15 , ' ' );     
    $out = $dev .date('d.m.Y H:i:s') . " Ankunft: " . $date . "  " . $locationName . " - " . $locationID ;
    }
  else
    {
    SetValue(IPS_GetVariableIDByName('AbfahrtDatumZeit',$IDlast),time());
    SetValue(IPS_GetVariableIDByName('Latitude',$IDlast),$latitude);
    SetValue(IPS_GetVariableIDByName('Longitude',$IDlast),$longitude);
    SetValue(IPS_GetVariableIDByName('LocationID',$IDlast),$locationID);
    SetValue(IPS_GetVariableIDByName('LocationName',$IDlast),$locationName);

    $dev = str_pad ( $device, 15 , ' ' );     
    $out = $dev .date('d.m.Y H:i:s') . " Abfahrt: " . $date . "  " . $locationName . " - " . $locationID ;
    }
        
  if ( $debug ) IPSLogger_Dbg(__FILE__,$out);
    
  logging($out);

  $HTMLBoxID = IPSUtil_ObjectIDByPath("Visualization.WebFront.Informationen.Geofencing.iPadMini.Map");
  DoGoogleMaps($HTMLBoxID,trim($latitude),trim($longitude));

  DoActions($isEntry,trim($device),trim($locationName));

/***************************************************************************//**
*	Erstellen einer GoogleMap
*******************************************************************************/
function DoGoogleMaps($HTMLBoxID,$latitude,$longitude,$hoehe=350,$breite=600,$zoomlevel=14)
    {

    $s  = "<iframe width='".$breite."' height='".$hoehe."' ";
    $s .= "src='http://maps.google.de/maps?hl=de";
    $s .= "&q=".$latitude.",".$longitude."&ie=UTF8&t=&z=".$zoomlevel;
    $s .= "&output=embed' frameborder='0' scrolling='no' ></iframe>";

    SetValue($HTMLBoxID,$s);

    } 
    
/***************************************************************************//**
*	Ausfuehren von Aktion bei Erreichen oder Verlassen
*******************************************************************************/
function DoActions($isEntry,$device,$location)
    {
    $debug = true;
    // LocationName und DeviceName hier eintragen
    $DeviceName      = 'iPhone';
    $LocationName     = 'Home';
    if ( $isEntry and $device==$DeviceName and $location==$LocationName )
       {
       // Hier wird was ausgefuehrt wenn das Geraet den Bereich erreicht
        if ( $debug ) IPSLogger_Dbg(__FILE__,$DeviceName." hat ".$LocationName." erreicht");
       
       }
    if ( !$isEntry and $device==$DeviceName and $location==$LocationName )
       {
       // Hier wird was ausgefuehrt wenn das Geraet den Bereich verlaesst
        if ( $debug ) IPSLogger_Dbg(__FILE__,$DeviceName." hat ".$LocationName." verlassen");

       }

    // LocationName und DeviceName hier eintragen
    $DeviceName      = 'iPadMini';
    $LocationName     = 'Home';
    if ( $isEntry and $device==$DeviceName and $location==$LocationName )
       {
       // Hier wird was ausgefuehrt wenn das Geraet den Bereich erreicht
        if ( $debug ) IPSLogger_Dbg(__FILE__,$DeviceName." hat ".$LocationName." erreicht");

       }
    if ( !$isEntry and $device==$DeviceName and $location==$LocationName )
       {
       // Hier wird was ausgefuehrt wenn das Geraet den Bereich verlaesst
        if ( $debug ) IPSLogger_Dbg(__FILE__,$DeviceName." hat ".$LocationName." verlassen");

       }
    }
  
/***************************************************************************//**
*	Logging
*******************************************************************************/
function logging($text,$file = 'geofency.log')
	{

	$ordner = IPS_GetKernelDir() . "logs\\Geofency";
   if ( !is_dir ( $ordner ) )
		mkdir($ordner);
	
	$ordner = IPS_GetKernelDir() . "logs\\Geofency\\logs";
   if ( !is_dir ( $ordner ) )
		mkdir($ordner);

   if ( !is_dir ( $ordner ) )
	   return;

    
	$time = date("d.m.Y H:i:s");
	$logdatei = IPS_GetKernelDir() . "logs\\Geofency\\logs\\" . $file;
	$datei = fopen($logdatei,"a+");
	fwrite($datei, $time .": ". $text . chr(13));
	fclose($datei);

	}
    
?>
